## firebird3.0 3.0.2.32703.ds4

=== extern/cloop/Makefile ===
MODULES	:= cloop tests tests/test1

WITH_FPC	:= 1

TARGET	:= release

CC	:= gcc
CXX	:= g++
LD	:= $(CXX)

SRC_DIR		:= src
BUILD_DIR	:= build
OUT_DIR		:= output
SHRLIB_EXT	:= .so
EXE_EXT		:=

OBJ_DIR := $(BUILD_DIR)/$(TARGET)
BIN_DIR := $(OUT_DIR)/$(TARGET)/bin
LIB_DIR := $(OUT_DIR)/$(TARGET)/lib

SRC_DIRS := $(addprefix $(SRC_DIR)/,$(MODULES))
OBJ_DIRS := $(addprefix $(OBJ_DIR)/,$(MODULES))

SRCS_C := $(foreach sdir,$(SRC_DIRS),$(wildcard $(sdir)/*.c))
SRCS_CPP := $(foreach sdir,$(SRC_DIRS),$(wildcard $(sdir)/*.cpp))

OBJS_C := $(patsubst $(SRC_DIR)/%.c,$(OBJ_DIR)/%.o,$(SRCS_C))
OBJS_CPP := $(patsubst $(SRC_DIR)/%.cpp,$(OBJ_DIR)/%.o,$(SRCS_CPP))

C_FLAGS := -ggdb -fPIC -MMD -MP -W -Wall -Wno-unused-parameter
CXX_FLAGS := $(C_FLAGS)
FPC_FLAGS := -Mdelphi

ifeq ($(TARGET),release)
	CXX_FLAGS += -O3
endif

ifeq ($(TARGET),debug)
	FPC_FLAGS += -g
endif

vpath %.c $(SRC_DIRS)
vpath %.cpp $(SRC_DIRS)

define compile
$1/%.o: %.c
	$(CC) -c $$(C_FLAGS) $$< -o $$@

$1/%.o: %.cpp
	$(CXX) -c $$(CXX_FLAGS) $$< -o $$@
endef

.PHONY: all mkdirs clean

all: mkdirs \
	$(BIN_DIR)/cloop	\
	$(BIN_DIR)/test1-c$(SHRLIB_EXT)	\
	$(BIN_DIR)/test1-c$(EXE_EXT)	\
	$(BIN_DIR)/test1-cpp$(SHRLIB_EXT)	\
	$(BIN_DIR)/test1-cpp$(EXE_EXT)	\
	$(BIN_DIR)/test1-pascal$(SHRLIB_EXT)	\
	$(BIN_DIR)/test1-pascal$(EXE_EXT)

mkdirs: $(OBJ_DIRS) $(BIN_DIR) $(LIB_DIR)

$(OBJ_DIRS) $(BIN_DIR) $(LIB_DIR):
	@mkdir -p $@

clean:
	@rm -rf $(BUILD_DIR) $(OUT_DIR)

$(foreach bdir,$(OBJ_DIRS),$(eval $(call compile,$(bdir))))

-include $(addsuffix .d,$(basename $(OBJS_C)))
-include $(addsuffix .d,$(basename $(OBJS_CPP)))

$(BIN_DIR)/cloop: \
	$(OBJ_DIR)/cloop/Expr.o \
	$(OBJ_DIR)/cloop/Generator.o \
	$(OBJ_DIR)/cloop/Lexer.o \
	$(OBJ_DIR)/cloop/Parser.o \
	$(OBJ_DIR)/cloop/Main.o \

	$(LD) $^ -o $@

$(SRC_DIR)/tests/test1/CalcCApi.h: $(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl c-header $@ CALC_C_API_H CALC_I

$(SRC_DIR)/tests/test1/CalcCApi.c: $(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl $(SRC_DIR)/tests/test1/CalcCApi.h
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl c-impl $@ CalcCApi.h CALC_I

$(SRC_DIR)/tests/test1/CalcCppApi.h: $(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl c++ $@ CALC_CPP_API_H calc I

$(SRC_DIR)/tests/test1/CalcPascalApi.pas: $(BIN_DIR)/cloop \
	$(SRC_DIR)/tests/test1/Interface.idl \
	$(SRC_DIR)/tests/test1/CalcPascalApi.interface.pas \
	$(SRC_DIR)/tests/test1/CalcPascalApi.implementation.pas
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl pascal $@ CalcPascalApi \
		--uses "SysUtils" \
		--interfaceFile $(SRC_DIR)/tests/test1/CalcPascalApi.interface.pas \
		--implementationFile $(SRC_DIR)/tests/test1/CalcPascalApi.implementation.pas \
		--exceptionClass CalcException

$(SRC_DIR)/tests/test1/CppTest.cpp: $(SRC_DIR)/tests/test1/CalcCppApi.h

$(BIN_DIR)/test1-c$(SHRLIB_EXT): \
	$(OBJ_DIR)/tests/test1/CalcCApi.o \
	$(OBJ_DIR)/tests/test1/CTest.o \

	$(LD) $^ -shared -ldl -o $@

$(BIN_DIR)/test1-c$(EXE_EXT): \
	$(OBJ_DIR)/tests/test1/CalcCApi.o \
	$(OBJ_DIR)/tests/test1/CTest.o \

	$(LD) $^ -ldl -o $@

$(BIN_DIR)/test1-cpp$(SHRLIB_EXT): \
	$(OBJ_DIR)/tests/test1/CppTest.o \

	$(LD) $^ -shared -ldl -o $@

$(BIN_DIR)/test1-cpp$(EXE_EXT): \
	$(OBJ_DIR)/tests/test1/CppTest.o \

	$(LD) $^ -ldl -o $@

$(BIN_DIR)/test1-pascal$(SHRLIB_EXT): \
	$(SRC_DIR)/tests/test1/PascalClasses.pas \
	$(SRC_DIR)/tests/test1/PascalLibrary.dpr \
	$(SRC_DIR)/tests/test1/CalcPascalApi.pas \

ifeq ($(WITH_FPC),1)
	fpc $(FPC_FLAGS) -fPIC -FU$(OBJ_DIR)/tests/test1 -o$(BIN_DIR)/test1-pascal$(SHRLIB_EXT) $(SRC_DIR)/tests/test1/PascalLibrary.dpr
endif

$(BIN_DIR)/test1-pascal$(EXE_EXT): \
	$(SRC_DIR)/tests/test1/PascalClasses.pas \
	$(SRC_DIR)/tests/test1/PascalTest.dpr \
	$(SRC_DIR)/tests/test1/CalcPascalApi.pas \

ifeq ($(WITH_FPC),1)
	fpc $(FPC_FLAGS) -FU$(OBJ_DIR)/tests/test1 -o$(BIN_DIR)/test1-pascal$(EXE_EXT) $(SRC_DIR)/tests/test1/PascalTest.dpr
endif

=== debian/changelog ===
firebird3.0 (3.0.2.32703.ds4-11ubuntu2) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:52:32 +0000

firebird3.0 (3.0.2.32703.ds4-11ubuntu1) bionic; urgency=medium

  * Define UCHAR_TYPE=uint16_t to avoid C++11 and fix FTBFS with icu59.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 27 Oct 2017 12:39:22 -0600

firebird3.0 (3.0.2.32703.ds4-11) unstable; urgency=medium

  * Upload to unstable
    Closes: #874517 -- configure.ac not supporting cross-build

 -- Damyan Ivanov <dmn@debian.org>  Thu, 07 Sep 2017 14:05:35 +0000

firebird3.0 (3.0.2.32703.ds4-10) experimental; urgency=low

  * Add patch from Helmut Grohne fixing cross-build support in configure.ac.
    See #874517
  * rules: s/BUILD/HOST/ in the OS check for --enable-raw-devices.
    Thanks to Helmut Grohne, see #874517
  * drop parallel-build.patch
    not needed with FB3
    using lockfile prevents cross-building. See #874517
    also drop procmail build-dependency as no longer needed
  * refresh remaining patches
  * Upload to experimental

 -- Damyan Ivanov <dmn@debian.org>  Thu, 07 Sep 2017 09:49:05 +0000

firebird3.0 (3.0.2.32703.ds4-9) unstable; urgency=medium

  * update years of copyright for debian/*
  * Do not ship employee.fbk in -examples, making the build deterministic.
    Ship a SQL script that creates employee.fdb instead.
    Closes: #867200 -- src:firebird3.0: Does not buildreproducibly (third
    take)
  * remove sample database from databases.conf
  * stop fiddling with employee.fdb attempting to make its creation
    deterministic.

 -- Damyan Ivanov <dmn@debian.org>  Tue, 01 Aug 2017 14:34:42 +0000

firebird3.0 (3.0.2.32703.ds4-8) unstable; urgency=medium

  * Use "frozen time" when calling faketime in order to produce deterministic
    employee.fbk (Closes: #867200 -- src:firebird3.0: Does not build
    reproducibly, broken in -6)
  * extend a bit the shorter long descriptions

 -- Damyan Ivanov <dmn@debian.org>  Mon, 31 Jul 2017 10:45:07 +0000

firebird3.0 (3.0.2.32703.ds4-7) unstable; urgency=medium

  * Add synthetic dependency on libicu to -server-core.
    This is needed because firebird loads libicu via dlopen()
    Missing dependency found by piuparts, see
    https://piuparts.debian.org/sid/fail/firebird3.0-server_3.0.2.32703.ds4-5.log

 -- Damyan Ivanov <dmn@debian.org>  Sun, 30 Jul 2017 06:12:57 +0000

firebird3.0 (3.0.2.32703.ds4-6) unstable; urgency=medium

  * Revert "Stop shipping employee.fdb in firebird3.0-examples"
  * Revert "stop trying to supply deterministic security3.fdb and employee.fdb
    in the package"
  * Ship employee sample database as a Firebird database backup (.fbk)
    Firebird backup files seem to be more deterministic compared to the raw
    database (provided you use faketime -- the backup contains timestamp
    of creation). See #867200

 -- Damyan Ivanov <dmn@debian.org>  Sat, 29 Jul 2017 17:17:41 +0000

firebird3.0 (3.0.2.32703.ds4-5) unstable; urgency=medium

  * update d/copyright to match new upstream release
  * Rework long descriptions to be more focused.
    Closes: #854433 -- irebird3.0-server-core: Please document that this is
    the package needed to use the embedded mode
  * Add Enhances: linfbclient2 and Recommends: firebird3.0-utils to -server-core
  * Add Recommends: firebird3.0-server-core and Suggests: firebird3.0-server
    to -utils
  * rules: print config.log when configure fails
  * Stop shipping employee.fdb in firebird3.0-examples.
    This was an unavoidable source for non-determinism
    Update README.Debian accordingly
  * Stop shipping security3.fdb in firebird3.0-server.
    Instead, create it during postinst
    This was the last source of non-determinism. Closes: #867200

 -- Damyan Ivanov <dmn@debian.org>  Wed, 26 Jul 2017 20:22:45 +0000

firebird3.0 (3.0.2.32703.ds4-4) unstable; urgency=medium

  * drop libib-util.triggers. dh_shlibdeps now handles the ldconfig trigger
  * add support for the nodoc parameter of DEB_BUILD_OPTIONS
  * rules: replace dpkg-parsechangelog invocation with SOURCE_DATE_EPOCH from
    dpkg's pkg-info.mk. Thanks, lintian
  * Declare conformance with Policy 4.0.0

 -- Damyan Ivanov <dmn@debian.org>  Wed, 21 Jun 2017 11:53:57 +0000

firebird3.0 (3.0.2.32703.ds4-3) unstable; urgency=medium

  * Upload to unstable

 -- Damyan Ivanov <dmn@debian.org>  Mon, 19 Jun 2017 11:59:28 +0000

firebird3.0 (3.0.2.32703.ds4-2) experimental; urgency=medium

  * fix short variant of the -full validation mode in gfix(1)
  * README.Debian: suggest a clean way for using unicode collations from old
    ICU versions
  * install README.Debian in -common-doc

 -- Damyan Ivanov <dmn@debian.org>  Mon, 12 Jun 2017 07:56:38 +0000

firebird3.0 (3.0.2.32703.ds4-1) experimental; urgency=medium

  * New upstream release
    + Drop 4 patches released upstream and fix offsets in 2 patches to apply
      cleanly
  * move password question reset from .config to .postinst
    Closes: #859236
  * patch fbguard/fbserver so that fbguard parent process exits to the OS only
    after fbserver is ready to serve requests
    Closes: #859234

 -- Damyan Ivanov <dmn@debian.org>  Wed, 05 Apr 2017 19:29:46 +0000

=== debian/control ===
Source: firebird3.0
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Firebird Group <pkg-firebird-general@lists.alioth.debian.org>
Uploaders: Damyan Ivanov <dmn@debian.org>
Build-Depends: 
 autoconf,
 automake,
 bison,
 debhelper (>= 9.20151219~),
 debhelper (>= 9.20160709~) | dh-systemd,
 faketime,
 gawk,
 libatomic-ops-dev (>= 1.2+cvs20091005),
 libboost-dev,
 libedit-dev,
 libicu-dev,
 libtommath-dev,
 libtool,
 po-debconf,
 rename,
 zlib1g-dev,
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 4.0.0
Vcs-Git: https://anonscm.debian.org/git/pkg-firebird/3.0.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-firebird/3.0.git
Homepage: http://firebirdsql.org/

Package: firebird3.0-server-core
Architecture: any
Multi-Arch: same
Breaks: firebird3.0-server (<< 3.0.0.32483.ds4-6~)
Replaces: firebird3.0-server (<< 3.0.0.32483.ds4-6~)
Depends: ${shlibs:Depends}, ${misc:Depends}, ${icu:Depends},
 firebird3.0-common (= ${source:Version}),
 firebird3.0-common-doc (= ${source:Version})
Recommends: firebird3.0-utils
Suggests: firebird3.0-server
Enhances: libfbclient2
Description: Firebird engine core
 Firebird database engine and support libraries. This package is required for
 embedded (serverless) access to local databases with the tools packaged in
 firebird3.0-utils or other binaries linked to the firebird client library,
 libfbclient2.
 .
 The rest of the binaries needed for running a full-featured,
 remotely-accessible Firebird server are in the firebird3.0-server package.

Package: firebird3.0-server
Architecture: any
Provides: firebird-server
Conflicts: firebird-server,
 firebird2.5-server-common,
 firebird2.1-super, firebird2.1-classic, firebird2.1-server-common,
Depends: adduser, ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
 firebird3.0-server-core (= ${binary:Version}),
 firebird3.0-utils (= ${binary:Version}),
 lsb-base (>= 3.0-6),
 ${misc:Depends}, debconf (>= 1.4.69),
 firebird3.0-common-doc (= ${source:Version})
Recommends: libib-util
Suggests: firebird3.0-doc
Description: Firebird Server - an RDBMS based on InterBase 6.0 code
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 This package contains the server binary as well as its configuration files.
 The default mode of operation is the so called "superclassic", which is a
 multi-threaded server -- each connection starts a separate thread and each
 connection has its own page cache. The two other operation modes -- "classic"
 (separate process/cache for each connection; started from the internet
 super-server inetd or xinetd) and "super" (single-threaded server process with
 shared cache between connections) are also available via configuration options.

Package: firebird3.0-utils
Architecture: any
Provides: firebird-utils
Conflicts: firebird-utils,
 firebird2.5-common, firebird2.5-server-common,
 firebird2.1-super, firebird2.1-classic, firebird2.1-common,
 firebird2.5-super, firebird2.5-classic-common
Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
 ${misc:Depends}, 
 firebird3.0-common-doc (= ${source:Version})
Recommends:
 firebird3.0-server-core,
Suggests:
 firebird3.0-doc,
 firebird3.0-server,
Description: Firebird command line utilities
 This package contains the utilities for managing Firebird databases:
  * isql-fb -- interactive console (original name isql)
  * gbak -- backup and restore databases
  * gfix -- check and repair databases
  * gsec -- manage users and roles
  * fbstat -- analyze databases (original name gstat)
  * nbackup -- incremental backup and file-level copy
  * gpre -- preprocess sources with embedded SQL

Package: libfbclient2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
 ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: Firebird client library
 Client library for connecting to the Firebird server/embedded engine.
 .
 See firebird3.0-server package for more information about Firebird.

Package: libib-util
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: Firebird UDF support library
 Contains utility functions used by Firebird User-Defined Functions (UDF) for
 memory management etc.
 .
 See firebird3.0-server package for more information about Firebird.

Package: firebird3.0-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: common files for firebird 3.0 server, client and utilities
 Common files for the Firebird server, client and user utilities.
 .
 These include the support scripts as well as configuration files in
 /etc/firebird/3.0.

Package: firebird-dev
Section: libdevel
Architecture: any
Conflicts: firebird2-dev, firebird2.1-dev, firebird2.5-dev
Replaces: firebird2-dev, firebird2.1-dev, firebird2.5-dev
Depends: libfbclient2 (>= ${source:Version}),
 libib-util (>= ${source:Version}),
 ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Suggests: firebird3.0-examples
Description: Development files for Firebird
 C header files for Firebird, useful if one compiles programs that use the
 Firebird client to work with Firebird databases.
 .
 See firebird3.0-server package for more information about Firebird.

Package: firebird3.0-examples
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Recommends: firebird3.0-dev
Description: Examples for Firebird database
 The examples included in this package are provided as samples and are also
 used by Firebird's testing suite (TCS). The examples are in the form
 of .h, .c, .e, .fdb and .gbk files.
 .
 See firebird3.0-server package for more information about Firebird.

Package: firebird3.0-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: Documentation files for firebird database version 3.0
 Various documents for firebird 3.0. These include the release notes, what's
 new in firebird 3.0, quick start guide, upgrade guide, list of ISQL
 enhancements etc.

Package: firebird3.0-common-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: copyright, licensing and changelogs of firebird3.0
 Copyright, licensing information and upstream changelog of firebird3.0.
 .
 Due to the size of the upstream change log and copyright/licensing summary,
 keeping them in a separate package saves space on mirrors and when installing
 firebird3.0 packages.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

FB_MAJOR:= $(shell awk '/FB_MAJOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_MINOR:= $(shell awk '/FB_MINOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_REV	:= $(shell awk '/FB_REV_NO/    { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_VER	:= $(FB_MAJOR).$(FB_MINOR)
FB_FULL_VER:= $(FB_VER).$(FB_REV)

include /usr/share/dpkg/pkg-info.mk
SOURCE_DATE := $(shell date -d@$(SOURCE_DATE_EPOCH) -u +"%Y-%m-%d")

CLIENT_SOVER := 2
UTIL_SOVER :=

ifndef FB_MAJOR
$(error FB_MAJOR not defined)
else ifndef FB_MINOR
$(error FB_MINOR not defined)
else ifndef FB_REV
$(error FB_REV not defined)
else ifndef FB_VER
$(error FB_VER not defined)
else ifndef FB_FULL_VER
$(error FB_FULL_VER not defined)
else ifndef CLIENT_SOVER
$(error CLIENT_SOVER not defined)
endif

# Use the following lines to set the compiler if
# the default Debian one can't be used (or you want to try
# the bleeding edge)
#export CC=gcc-5
#export CXX=g++-5
#export CPP=cpp-5
#export CXXPP=cpp-5


export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
   NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build $(DEB_HOST_GNU_TYPE)
else
	confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_OS), linux)
	confflags += --enable-raw-devices
else
	confflags += --disable-raw-devices
endif

DOC := /usr/share/doc/firebird${FB_VER}-common-doc
ULFB := /usr/lib/${DEB_HOST_MULTIARCH}/firebird/${FB_VER}
USFB := /usr/share/firebird/${FB_VER}
VAR := /var/lib/firebird/${FB_VER}
RUN := /run/firebird${FB_VER}

export DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow
export DEB_CXXFLAGS_MAINT_APPEND := -std=gnu++98 -DUCHAR_TYPE=uint16_t -fno-lifetime-dse -fno-delete-null-pointer-checks -fno-strict-aliasing
export DEB_CFLAGS_MAINT_APPEND := -fno-strict-aliasing

DPKG_EXPORT_BUILDFLAGS := 1
include /usr/share/dpkg/buildflags.mk

confflags += --disable-rpath --with-gpre-cobol \
	     --with-system-editline --prefix=${ULFB} --with-fbsbin=/usr/sbin \
	     --with-bin=/usr/bin \
	     --with-fbconf=${ULFB} --with-fbdoc=${DOC} \
	     --with-fbudf=${ULFB}/UDF --with-fbsample=${DOC}/examples \
	     --with-fbsample-db=${DOC}/examples/empbuild \
	     --with-fbhelp=${VAR}/system --with-fbintl=${ULFB}/intl \
	     --with-fbmisc=${ULFB}/misc --with-fbsecure-db=${VAR}/system \
	     --with-fblog=/var/log/firebird --with-fbglock=${RUN} \
	     --with-fblogfilename=firebird$(FB_VER).log \
	     --with-fbplugins=${ULFB}/plugins \
	     --with-fbmsg=${ULFB}

# see #575564
export FIREBIRD_LOCK := $(CURDIR)/debian/tmp-lock

# Packaging is split into several packages:
# * firebirdVV-server (incl libengineXX)
# * libfbclient2
# * libib-util
# * firebirdVV-utils
# * firebirdVV-common (common parts to client and utils)
# * firebirdVV-common-doc (big copyright and changelog one place)
# * firebirdVV-doc
# * firebirdVV-examples
# * firebird-dev

autogen: autogen-stamp
autogen-stamp:
	NOCONFIGURE=1 sh autogen.sh
	touch $@

.PHONY: configure
configure: configure-stamp
configure-stamp: autogen-stamp
	@echo ================================
	@echo ==== Starting configuration ====
	@echo ================================
	dh_testdir

	-sh debian/clean-after-build.sh

	chmod u+x ./configure
	dpkg-buildflags --status
	./configure $(confflags) || ( id; cat config.log; exit 1 )

	touch $@

ifneq (,$(filter nodoc,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
    MANUALS_BASE :=
else
MANUALS_BASE := isql-fb gbak gfix gpre gsec fbstat nbackup \
	       fbsvcmgr fbtracemgr fbguard \
	       fb_lock_print firebird fb_config
endif
MANUALS := $(addprefix debian/man/,$(addsuffix .1,$(MANUALS_BASE)))

.PHONY: build-manuals
build-manuals: $(MANUALS)

%.1 : %.pod
	pod2man -c "Firebird documentation" --release "Firebird $(FB_VER)"  $< > $@

.PHONY: build build-arch build-indep
# not really possible to build only arch-dep/arch-indep components
# examples (arch-indep) require building of the engine (arch-dep)
build build-arch build-indep: build-stamp

build-stamp: $(MANUALS) build-firebird-stamp
	touch $@

FB_IMG := debian/firebird-image

build-server-stamp: configure-stamp
	echo Starting build
	dh_testdir
	[ -d $(FIREBIRD_TMP) ] || mkdir $(FIREBIRD_TMP)
	$(MAKE) $(NJOBS) QUIET=1

	rm -rf $(FB_IMG)
	#fakeroot $(MAKE) -C gen -f Makefile.install buildRoot
	#mv ./gen/buildroot ./debian/firebird-build
	cp -a ./gen/Release/firebird $(FB_IMG)
	cp -a src/include/gen $(FB_IMG)/include-gen

	echo "Built image contents"
	cd $(FB_IMG) && ls -lR

	touch $@

build-firebird-stamp: build-server-stamp

	touch $@

.PHONY: clean
clean:
	dh_testdir
	
	sh debian/clean-after-build.sh
	
	rm -f $(MANUALS)
	
	rm -f 	build-stamp build-server-stamp configure-stamp \
		autogen-stamp install-stamp build-firebird-stamp
	
	# re-generated in autogen target
	rm -f builds/make.new/config/config		\
	      builds/make.new/config/config.guess	\
	      builds/make.new/config/config.h.in	\
	      builds/make.new/config/config.sub 	\
	      builds/make.new/config/ltmain.sh		\
	      builds/make.new/config/install-sh		\
	      aclocal.m4				\
	      configure
	
	rm -rf	debian/firebird-image
	
	debconf-updatepo
	
	dh_clean
	
	@echo FB_MAJOR = $(FB_MAJOR)
	@echo FB_MINOR = $(FB_MINOR)
	@echo FB_REV   = $(FB_REV)
	@echo FB_VER   = $(FB_VER)
	@echo FB_FULL_VER = $(FB_FULL_VER)
	@echo CLIENT_SOVER= $(CLIENT_SOVER)
	@echo UTIL_SOVER= $(UTIL_SOVER)

.PHONY: install
install: install-stamp
install-stamp: DH_OPTIONS=
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	sh debian/make_packages.sh

	touch $@

.PHONY: binary-indep
binary-indep: install-stamp
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -p firebird$(FB_VER)-common-doc
	dh_installdocs -Xchangelog -Xcopyright -p firebird$(FB_VER)-doc
	dh_installman -i
	dh_installexamples -i
	dh_installlogrotate -i --name firebird$(FB_VER)
	dh_installchangelogs ChangeLog -p firebird$(FB_VER)-common-doc
	dh_lintian -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i

	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

ICU_VER := $(shell icu-config --icudata|sed 's/[^0-9]*\([0-9]\+\).*/\1/')

.PHONY: binary-arch
# Build architecture-dependent files here.
binary-arch: install-stamp
	dh_testdir -a
	dh_testroot -a
	dh_installdebconf -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installinit -pfirebird$(FB_VER)-server --name=firebird$(FB_VER)
	dh_systemd_enable -pfirebird$(FB_VER)-server --name=firebird$(FB_VER)
	dh_installcron -a
	dh_installman -a
	dh_installinfo -a
	dh_installlogrotate -a --name firebird$(FB_VER)
	dh_lintian -a
	dh_strip -a --ddeb-migration="firebird$(FB_VER)-dbg (<< 3.0.0.32383+20160312.ds4-1~)"
	dh_link -a -A
	dh_compress -a
	dh_fixperms -a

	dh_makeshlibs -p libfbclient$(CLIENT_SOVER) -V'libfbclient$(CLIENT_SOVER) (>= $(FB_FULL_VER)~)'
	dh_makeshlibs -p libib-util$(UTIL_SOVER) -V'libib-util$(UTIL_SOVER) (>= $(FB_FULL_VER)~)'

	dpkg-gensymbols -plibfbclient$(CLIENT_SOVER) -Pdebian/libfbclient$(CLIENT_SOVER)
	dpkg-gensymbols -plibib-util$(UTIL_SOVER) -Pdebian/libib-util$(UTIL_SOVER)

	dh_installdeb -a
	dh_shlibdeps -a -X /plugins/
	dh_gencontrol -a -- -V"icu:Depends=libicu$(ICU_VER)"
	dh_md5sums -a
	dh_builddeb -a

.PHONY: binary
binary: binary-indep binary-arch

.PHONY: get-orig-source
get-orig-source:
	uscan

=== debian/watch ===
# watch control file for uscan
# you can run the "uscan" command
# to check for upstream updates and more.
# Full-site-with-pattern  [Version  [Action]]

version=3
opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-\d+//;s/-(?=\D)/~/g" \
  http://sf.net/firebird/[Ff]irebird-(3\.0\..*).tar.bz2 \
  debian sh debian/repack.sh

## firebird3.0 3.0.5.33100.ds4

=== CMakeLists.txt ===
#
# firebird (trunk)
#
#  This file has following organization:
#  1. cmake settings
#  2. project settings
#  3. packages
#  4. configure
#  5. compiler & linker settings
#  6. pre-build
#  7. build
#

################################################################################
#
# cmake settings
#
################################################################################

cmake_minimum_required(VERSION 2.8.12)

# In-source builds are not possible and so disabled.
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR
        "CMake generation for Firebird is not possible within the source directory!"
        "\n Remove the CMakeCache.txt file and try again from another folder, e.g.:"
        "\n "
        "\n rm CMakeCache.txt"
        "\n mkdir build"
        "\n cd build"
        "\n cmake .."
    )
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/builds/cmake)

if (NATIVE_BUILD_DIR)
    get_filename_component(NATIVE_BUILD_DIR ${NATIVE_BUILD_DIR} ABSOLUTE)
else()
    set(NATIVE_BUILD_DIR ${CMAKE_BINARY_DIR})
endif()

# Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake Targets")

################################################################################
#
# project settings
#
################################################################################

project("firebird" C CXX)

########################################
# build type settings
########################################

# Define build mode
if (NOT DEFINED CMAKE_BUILD_TYPE OR "${CMAKE_BUILD_TYPE}" STREQUAL "")
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build.")
endif()

# Qt with MSVC does not have multiconfiguration option by default,
#  so we create it.
set(DEFAULT_CONFIGURATION)

# Set build types if none was specified
if (NOT DEFINED CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES Debug Release MinSizeRel RelWithDebInfo)
    set(DEFAULT_CONFIGURATION ${CMAKE_BUILD_TYPE})
endif()

########################################
# Output directory settings
########################################

set(output_dir ${CMAKE_BINARY_DIR}/${PROJECT_NAME})
set(boot_dir ${CMAKE_BINARY_DIR}/src)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${output_dir})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${output_dir})

if (MSVC OR XCODE)
    set(output_dir ${output_dir}/$<CONFIG>)
    set(boot_dir ${boot_dir}/$<CONFIG>)
endif()

if (MSVC AND DEFAULT_CONFIGURATION)
    foreach(conf ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${conf} conf2)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${conf2} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${DEFAULT_CONFIGURATION})
    endforeach()
endif()

if (XCODE)
    foreach(conf ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${conf} conf2)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${conf2} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${conf}/bin)
    endforeach()
elseif (UNIX)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${output_dir}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${output_dir}/bin)
endif()

################################################################################
#
# packages
#
################################################################################

########################################
# icu
########################################

if (UNIX)
    if (NOT ICU_INCLUDE_DIR)
        find_path(ICU_INCLUDE_DIR unicode/ucnv.h
            PATHS
                /usr/include
                /usr/include/x86_64-linux-gnu
                /usr/local/include
                /opt/local/include
                /usr/local/opt/icu4c/include
            CMAKE_FIND_ROOT_PATH_BOTH
        )
        if ("${ICU_INCLUDE_DIR}" STREQUAL "ICU_INCLUDE_DIR-NOTFOUND")
            message(FATAL_ERROR "ICU headers not found!")
        endif()
    endif()
    if (CMAKE_CROSSCOMPILING)
        execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory
            ${ICU_INCLUDE_DIR}/unicode
            ${CMAKE_BINARY_DIR}/unicode
        )
        set(ICU_INCLUDE_DIR ${CMAKE_BINARY_DIR})
    endif()
    set(ICU_INCLUDE_DIRS ${ICU_INCLUDE_DIR})
    include_directories(${ICU_INCLUDE_DIRS})
endif()

################################################################################
#
# configure
#
################################################################################

include(Configure)

if (FREEBSD)
    # temporary
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})
endif()

set(FB_PREFIX ${CMAKE_INSTALL_PREFIX}/${PROJECT_NAME})
set(FB_IPC_NAME "FirebirdIPI")
set(FB_LOGFILENAME "firebird.log")
set(FB_PIPE_NAME "interbas")
set(FB_SERVICE_NAME "gds_db")
set(FB_SERVICE_PORT 3050)

if (WIN32)
    set(FB_PREFIX "c:\\\\Program Files\\\\Firebird\\\\")
    set(FB_IPC_NAME "FIREBIRD")
endif()

set(AUTOCONFIG_SRC ${CMAKE_SOURCE_DIR}/src/include/gen/autoconfig.h.in)
set(AUTOCONFIG ${CMAKE_BINARY_DIR}/src/include/gen/autoconfig.h)
configure_file(${AUTOCONFIG_SRC} ${AUTOCONFIG} @ONLY)

################################################################################
#
# compiler & linker settings
#
################################################################################

add_definitions(-DDEV_BUILD)

if (WIN32)
    set(OS_DIR win32)
    set(VERSION_RC ${CMAKE_SOURCE_DIR}/src/jrd/version.rc)

    if (MSVC)
        set(disable_msvc_warnings "/wd4996")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP ${disable_msvc_warnings}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP ${disable_msvc_warnings}")
        
        if (MSVC_STATIC_RUNTIME)
            set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
            set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
            set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
            set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        endif()
    endif(MSVC)

    set(LIB_Ws2_32 Ws2_32)
    set(LIB_comctl32 comctl32)
    set(LIB_mpr mpr)
    set(LIB_version version)
endif(WIN32)

if (MINGW)
    # clear unix-style prefixes
    set(CMAKE_SHARED_LIBRARY_PREFIX)
    set(CMAKE_SHARED_MODULE_PREFIX)
    set(CMAKE_STATIC_LIBRARY_PREFIX)

    add_definitions(-D_WIN32_WINNT=0x0600)
endif()

if (UNIX)
    set(OS_DIR posix)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -msse4")

    if (NOT CMAKE_CROSSCOMPILING)
        set(LIB_readline readline)
    endif()
    if (NOT FREEBSD)
        set(LIB_dl dl)
    endif()
endif()

if (NOT LINUX AND (CLANG OR IOS))
    set(LIB_iconv iconv)
endif()

if (FREEBSD OR APPLE)
    include_directories(/usr/local/include)
    link_directories(/usr/local/lib)
endif()

if (APPLE)
    set(OS_DIR darwin)

    if (NOT CMAKE_CROSSCOMPILING)
        include_directories(/opt/local/include)
        link_directories(/opt/local/lib)
        link_directories(/usr/local/opt/icu4c/lib)
    endif()

    find_library(LIB_CoreFoundation CoreFoundation)
elseif (UNIX)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
endif()

################################################################################
#
# pre-build
#
################################################################################

if (WIN32)
    # icu
    if (NOT ICU_EXTRACT)
        message(STATUS "Extracting pre-built ICU")
        set(ICU_EXTRACT ${CMAKE_CURRENT_SOURCE_DIR}/extern/icu/icu.exe -y
            CACHE STRING "ICU extraction variable")
        execute_process(COMMAND ${ICU_EXTRACT})
    endif()

    # zlib
    if (NOT ZLIB_EXTRACT)
        message(STATUS "Extracting pre-built zlib")
        set(ZLIB_EXTRACT ${CMAKE_CURRENT_SOURCE_DIR}/extern/zlib/zlib.exe -y
            CACHE STRING "zlib extraction variable")
        execute_process(COMMAND ${ZLIB_EXTRACT})
    endif()
endif()

if (UNIX)    
    file(GLOB vers_src "${CMAKE_SOURCE_DIR}/builds/posix/*.vers")
    foreach(f ${vers_src})
        get_filename_component(name ${f} NAME)
        set(name ${CMAKE_BINARY_DIR}/builds/posix/${name})

        if (AIX)
            file(WRITE ${name} "#!\n")
        elseif (LINUX)
            file(WRITE ${name} "{\nglobal:\n")
        endif()

        file(STRINGS ${f} strings)
        foreach(s ${strings})
            string(REGEX REPLACE "#.*$" "" s "${s}")
            string(STRIP "${s}" s)
            if (NOT "${s}" STREQUAL "")
                if (AIX)
                    file(APPEND ${name} "\t${s}\n")
                elseif (APPLE)
                    file(APPEND ${name} "\t_${s}\n")
                elseif (HPUX)
                    file(APPEND ${name} "+e ${s}\n")
                else()
                    file(APPEND ${name} "\t${s};\n")
                endif()
            endif()
        endforeach()

        if (LINUX)
            file(APPEND ${name} "local:\n\t*;\n};\n")
        endif()
    endforeach()
endif()

################################################################################
#
# build
#
################################################################################

include(BuildFunctions)

if (NOT CMAKE_CROSSCOMPILING)

create_boot_commands()
create_master_commands()

endif() # if (NOT CMAKE_CROSSCOMPILING)

crosscompile_prebuild_steps()

include_directories("extern/libtommath")
include_directories("extern/icu/include")
include_directories("extern/zlib")

include_directories("src/include")
include_directories("src/include/gen")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/src/include")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/src/include/gen")

########################################
# LIBRARY libtommath
########################################

file(GLOB libtommath_src "extern/libtommath/*.c" "extern/libtommath/*.h")

add_library             (libtommath ${libtommath_src})
project_group           (libtommath Extern)

########################################
# EXECUTABLE btyacc
########################################

file(GLOB btyacc_src "extern/btyacc/*.c" "extern/btyacc/*.h")

if (NOT CMAKE_CROSSCOMPILING)

add_executable          (btyacc ${btyacc_src})
project_group           (btyacc Extern)
set_output_directory    (btyacc . CURRENT_DIR)

endif() # if (NOT CMAKE_CROSSCOMPILING)

########################################
# EXECUTABLE cloop
########################################

file(GLOB cloop_src "extern/cloop/src/cloop/*.cpp" "extern/cloop/src/cloop/*.h")

add_executable          (cloop ${cloop_src})
project_group           (cloop Extern)

########################################
# subdirectories
########################################

add_subdirectory("examples")
add_subdirectory("src")

################################################################################

=== debian/changelog ===
firebird3.0 (3.0.5.33100.ds4-2) unstable; urgency=medium

  * rules: fail if unable to determine ICU version.
  * rules: deremine ICU version via pkg-config
    Closes: #921683, thanks to Matthias Klose

 -- Damyan Ivanov <dmn@debian.org>  Fri, 08 Feb 2019 07:59:55 +0000

firebird3.0 (3.0.5.33100.ds4-1) unstable; urgency=medium

  * New upstream snapshot from the B3_0_Release branch

 -- Damyan Ivanov <dmn@debian.org>  Thu, 07 Feb 2019 12:34:25 +0000

firebird3.0 (3.0.5.33086.ds4-2) unstable; urgency=medium

  * fix typo in xinetd configuration (Closes: #919422)

 -- Damyan Ivanov <dmn@debian.org>  Tue, 15 Jan 2019 21:31:57 +0000

firebird3.0 (3.0.5.33086.ds4-1) unstable; urgency=medium

  * New upstream snapshot from the B3_0_Release branch
  * Declare conformance with Policy 4.3.0 (no chanes needed)
  * replace usage of dpkg-maintscript-helper with a .maintscript file

 -- Damyan Ivanov <dmn@debian.org>  Fri, 11 Jan 2019 14:17:53 +0000

firebird3.0 (3.0.5.33083.ds4-1) unstable; urgency=medium

  * New upstream snapshot from the B3_0_Release branch
  * add Build-Depends-Package field to *.symbols files; thanks, lintian

 -- Damyan Ivanov <dmn@debian.org>  Wed, 05 Dec 2018 09:51:45 +0000

firebird3.0 (3.0.5.33077.ds4-1) unstable; urgency=medium

  * New upstream snapshot from the B3_0_Release branch

 -- Damyan Ivanov <dmn@debian.org>  Wed, 07 Nov 2018 11:51:58 +0000

firebird3.0 (3.0.4.33066.ds4-1) unstable; urgency=medium

  * functions.sh/firebird_config_postinst: route service start via
    invoke-rc.d.
    Thanks to Andreas Beckmann (Closes: #910989)
  * New upstream snapsot from the B3_0_Release branch
  * drop .gitignore files from d/copyright (excluded from repackaged sources)

 -- Damyan Ivanov <dmn@debian.org>  Sun, 14 Oct 2018 18:33:32 +0000

firebird3.0 (3.0.4.33055.ds4-2) unstable; urgency=medium

  * Porting efforts:
    + c++-std.patch: apply also to prefix.freebsd{,-amd64}
    + patch prefix.freebsd* to match prefix.linux
      the -msse4 option is of particular interest
    + deb/march-i486.patch: extend to cover prefix.freebsd
    + add patch teaching SockAddr.h about kfreebsd's AF_INET6
    Thanks to James Clarke
    + patch fallback definition of MAXPATHLEN outside of WinNT conditional
      helps the hurd build move a bit further
  * also remove .gitignore files when repacking upstream sources
  * init: remove left over setting of the FIREBIRD environment variable.
    Not needed, and actually harmful, since it points to a non-existing path
    Thanks to Jan Korbel, Closes: #901959

 -- Damyan Ivanov <dmn@debian.org>  Sun, 07 Oct 2018 07:15:01 +0000

firebird3.0 (3.0.4.33055.ds4-1) unstable; urgency=medium

  * New upstream snapshot from the B3_0_Release branch
  * add basic autopkgtest
    for now tests database creation, backup, restore and validation

 -- Damyan Ivanov <dmn@debian.org>  Fri, 05 Oct 2018 08:50:33 +0000

firebird3.0 (3.0.4.33054.ds4-2) unstable; urgency=medium

  * ad patch from John David Anglin fixing build problem on HPPA
    (Closes: #858868)

 -- Damyan Ivanov <dmn@debian.org>  Tue, 25 Sep 2018 05:35:45 +0000

firebird3.0 (3.0.4.33054.ds4-1) unstable; urgency=medium

  * pack-upstream-snapshot: adapt to git, drop date from upstream version
    upstream version already includes a build number, which is
    increasing and unique
  * remove another HTML file without source when repackaging
  * New upstream snapshot from the B3_0_Release branch
  * update debian/copyright
  * drop out/nbackup-decompress-level1.patch (fixed upstream)
  * adapt/refresh remaining patches
  * move source.lintian-overrides to source/lintian-overrides
  * add debian/upstream/metadata file
  * repack.sh: remove empty directories
  * honour-buildflags.patch: stop overriding CXXFLAGS from the environment
  * bump debhelper compatibility level to 11
  * add Rules-Requires-Root: no
  * declare conformance with Policy 4.2.1

 -- Damyan Ivanov <dmn@debian.org>  Mon, 24 Sep 2018 09:40:59 +0000

firebird3.0 (3.0.3.32900.ds4-4) unstable; urgency=medium

  * add patch from upstream master branch adding support for building on
    Linux/RiscV64
  * add missing builds/posix/prefix.linux_riscV64 completing RiscV64 support.
    Thanks to Manuel A. Fernandez Montecelo (Closes: #895257)
  * refresh line offsets of two patches

 -- Damyan Ivanov <dmn@debian.org>  Wed, 20 Jun 2018 13:06:25 +0000

firebird3.0 (3.0.3.32900.ds4-3) unstable; urgency=medium

  * disable UDFs in firebird.conf due to a remote authenticated code execution
    vilnerability
    https://www.tenable.com/security/research/tra-2017-36 (CVE-2017-11509)
    http://tracker.firebirdsql.org/browse/CORE-5518
  * bump Standards-Version to 4.1.4 (no changes needed)
  * fix typo in fbserver-startup.patch; thanks, lintian
  * drop get-orig-source target from debian/rules; was an alias for uscan
  * copyright: fix a lintian warning about double license definition
  * move databases.conf and fbtrace.conf symlinks from -server-core to -server
    the real files are in -server already. Closes: #873913

 -- Damyan Ivanov <dmn@debian.org>  Fri, 20 Apr 2018 13:42:14 +0000

firebird3.0 (3.0.3.32900.ds4-2) unstable; urgency=medium

  * add c++-std.patch, adding --std=gnu++03 to several build prefix files
    Closes: #889627

 -- Damyan Ivanov <dmn@debian.org>  Mon, 05 Feb 2018 15:50:05 +0000

firebird3.0 (3.0.3.32900.ds4-1) unstable; urgency=medium

  * move myself from Uploaders to Maintainer
  * point Vcs-* to salsa.debian.org
  * drop no-binary-metadata.patch
  * convert debian/copyright to copyright-format/1.0
  * convert d/watch to version 4, with source URL from upstream site (not
    sf.net) and automatic repackaging
  * exclude all *.pdf under doc/ when repackaging
  * New upstream version 3.0.3.32900.ds4
  * update copyright
  * drop dupl-unique-constraint.patch (applied upstream)
  * adapt patches to apply to the new release
  * refresh patches to apply cleanly
  * rules: drop -std and -fno-delete-null-pointer-checks from


=== debian/control ===
--- 
+++ 
@@ -1,31 +1,27 @@
 Source: firebird3.0
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Firebird Group <pkg-firebird-general@lists.alioth.debian.org>
-Uploaders: Damyan Ivanov <dmn@debian.org>
-Build-Depends: 
+Maintainer: Damyan Ivanov <dmn@debian.org>
+Build-Depends:
  autoconf,
  automake,
- bison,
- debhelper (>= 9.20151219~),
- debhelper (>= 9.20160709~) | dh-systemd,
- faketime,
+ debhelper-compat (= 11),
  gawk,
- libatomic-ops-dev (>= 1.2+cvs20091005),
  libboost-dev,
  libedit-dev,
  libicu-dev,
  libtommath-dev,
  libtool,
+ pkg-config,
  po-debconf,
  rename,
  zlib1g-dev,
 Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 4.0.0
-Vcs-Git: https://anonscm.debian.org/git/pkg-firebird/3.0.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-firebird/3.0.git
+Standards-Version: 4.3.0
+Vcs-Git: https://salsa.debian.org/firebird-team/firebird3.0.git
+Vcs-Browser: https://salsa.debian.org/firebird-team/firebird3.0
 Homepage: http://firebirdsql.org/
+Rules-Requires-Root: no
 
 Package: firebird3.0-server-core
 Architecture: any
@@ -53,6 +49,7 @@
 Conflicts: firebird-server,
  firebird2.5-server-common,
  firebird2.1-super, firebird2.1-classic, firebird2.1-server-common,
+Replaces: firebird3.0-server-core (<< 3.0.3.32900.ds4-3~)
 Depends: adduser, ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
  firebird3.0-server-core (= ${binary:Version}),
  firebird3.0-utils (= ${binary:Version}),
@@ -69,12 +66,11 @@
  under a variety of names since 1981.
  .
  This package contains the server binary as well as its configuration files.
- The default mode of operation is the so called "superclassic", which is a
- multi-threaded server -- each connection starts a separate thread and each
- connection has its own page cache. The two other operation modes -- "classic"
- (separate process/cache for each connection; started from the internet
- super-server inetd or xinetd) and "super" (single-threaded server process with
- shared cache between connections) are also available via configuration options.
+ The default mode of operation is the so called "super", which is a
+ single-threaded server process with shared database cache between
+ connections. The two other operation modes -- "classic" (separate
+ process/cache for each connection) and "superclassic" (separate thread/cache
+ for each connection) are also available via configuration options.
 
 Package: firebird3.0-utils
 Architecture: any
@@ -84,7 +80,7 @@
  firebird2.1-super, firebird2.1-classic, firebird2.1-common,
  firebird2.5-super, firebird2.5-classic-common
 Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
- ${misc:Depends}, 
+ ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Recommends:
  firebird3.0-server-core,
@@ -109,7 +105,8 @@
  ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Description: Firebird client library
- Client library for connecting to the Firebird server/embedded engine.
+ Client library for connecting to the Firebird server. It can also be used for
+ direct (embedded) database access.
  .
  See firebird3.0-server package for more information about Firebird.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-# Uncomment this to turn on verbose mode. 
+# Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
 FB_MAJOR:= $(shell awk '/FB_MAJOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
@@ -65,7 +65,7 @@
 RUN := /run/firebird${FB_VER}
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow
-export DEB_CXXFLAGS_MAINT_APPEND := -std=gnu++98 -DUCHAR_TYPE=uint16_t -fno-lifetime-dse -fno-delete-null-pointer-checks -fno-strict-aliasing
+export DEB_CXXFLAGS_MAINT_APPEND := -DUCHAR_TYPE=uint16_t -fno-lifetime-dse -fno-strict-aliasing
 export DEB_CFLAGS_MAINT_APPEND := -fno-strict-aliasing
 
 DPKG_EXPORT_BUILDFLAGS := 1
@@ -74,6 +74,7 @@
 confflags += --disable-rpath --with-gpre-cobol \
 	     --with-system-editline --prefix=${ULFB} --with-fbsbin=/usr/sbin \
 	     --with-bin=/usr/bin \
+	     --with-fblib=/usr/lib/${DEB_HOST_MULTIARCH} \
 	     --with-fbconf=${ULFB} --with-fbdoc=${DOC} \
 	     --with-fbudf=${ULFB}/UDF --with-fbsample=${DOC}/examples \
 	     --with-fbsample-db=${DOC}/examples/empbuild \
@@ -158,6 +159,12 @@
 
 	echo "Built image contents"
 	cd $(FB_IMG) && ls -lR
+
+	sed -i -e's,-I$$fb_incdir,,'  $(FB_IMG)/bin/fb_config
+	sed -i -e's,-L$$fb_libdir ,,' $(FB_IMG)/bin/fb_config
+
+	sh $(FB_IMG)/bin/fb_config --cflags
+	sh $(FB_IMG)/bin/fb_config --libs
 
 	touch $@
 
@@ -233,7 +240,10 @@
 	dh_md5sums -i
 	dh_builddeb -i
 
-ICU_VER := $(shell icu-config --icudata|sed 's/[^0-9]*\([0-9]\+\).*/\1/')
+ICU_VER := $(shell pkg-config icu-i18n --modversion|sed 's/[^0-9]*\([0-9]\+\).*/\1/')
+ifeq ($(ICU_VER),)
+    $(error Unable to determine ICU version)
+endif
 
 .PHONY: binary-arch
 # Build architecture-dependent files here.
@@ -244,13 +254,13 @@
 	dh_installexamples -a
 	dh_installmenu -a
 	dh_installinit -pfirebird$(FB_VER)-server --name=firebird$(FB_VER)
-	dh_systemd_enable -pfirebird$(FB_VER)-server --name=firebird$(FB_VER)
+	dh_installsystemd -pfirebird$(FB_VER)-server --name=firebird$(FB_VER)
 	dh_installcron -a
 	dh_installman -a
 	dh_installinfo -a
 	dh_installlogrotate -a --name firebird$(FB_VER)
 	dh_lintian -a
-	dh_strip -a --ddeb-migration="firebird$(FB_VER)-dbg (<< 3.0.0.32383+20160312.ds4-1~)"
+	dh_strip -a
 	dh_link -a -A
 	dh_compress -a
 	dh_fixperms -a
@@ -269,7 +279,3 @@
 
 .PHONY: binary
 binary: binary-indep binary-arch
-
-.PHONY: get-orig-source
-get-orig-source:
-	uscan

=== debian/tests/control ===
Tests: assorted-tools
Depends: firebird3.0-server-core, firebird3.0-utils, firebird3.0-examples
